unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Db, DBTables;

type
  TForm1 = class(TForm)
    Buttonuj: TButton;
    Buttonmod: TButton;
    Buttontorol: TButton;
    buttonment: TButton;
    buttonmegsem: TButton;
    Listboxea: TListBox;
    Editazon: TEdit;
    Editcim: TEdit;
    Edithossz: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Database1: TDatabase;
    Query_eloadasok: TQuery;
    queryearesz: TQuery;
    inserteloado: TQuery;
    updateeloadas: TQuery;
    deleteeloadas: TQuery;
    comboea: TComboBox;
    query_eloado: TQuery;
    procedure FormShow(Sender: TObject);
    procedure ListboxeaClick(Sender: TObject);
    procedure ButtonujClick(Sender: TObject);
    procedure ButtonmodClick(Sender: TObject);
    procedure ButtontorolClick(Sender: TObject);
    procedure buttonmentClick(Sender: TObject);
    procedure buttonmegsemClick(Sender: TObject);
  private
    azon,eloadok:tstringlist;
    aktazon: string;
    uje:boolean;
  procedure frissit;
  procedure betolt;
  procedure aktival(aktiv:boolean);
  procedure sqlfuttat(sql:tquery; torles:boolean);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

procedure tform1.frissit;

{Ez tolti fel az adatokat. listbox es egyebek}
begin
listboxea.Clear;
eloadok.clear;
azon.Clear;
comboea.Clear;
query_eloadasok.open;
while not (query_eloadasok.eof) do
        begin
        azon.add(query_eloadasok['Eazon']);
        listboxea.Items.Add(query_eloadasok['cim']);
        query_eloadasok.Next;
        end;

query_eloado.open;
while not (query_eloado.eof) do
        begin
        comboea.Items.Add(query_eloado['nev']);
        eloadok.add(query_eloado['razon']);
        query_eloado.Next;
        end;

query_eloado.close;
query_eloadasok.Close;

end;

{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
begin
database1.Connected:=true;
azon:=tstringlist.Create;
eloadok:=tstringlist.create;
frissit;
if listboxea.Items.Count>-1 then listboxea.Itemindex:=0;
betolt;
end;

procedure tform1.betolt;
//var i,j:integer;

{Ez tolti be az adatokat a textekbe meg ilyenekbe, amikor egy
eara kattintok.}
begin
if listboxea.Itemindex>=0 then
        begin
        aktazon:=azon[listboxea.Itemindex];
        queryearesz.ParamByName('azonosito').AsString:=aktazon;
        queryearesz.open;
        if not queryearesz.Eof then
                begin
                editazon.text:=aktazon;
                editcim.text:=queryearesz['cim'];
                edithossz.text:=queryearesz['hossz'];
                comboea.itemindex:=eloadok.indexof(queryearesz['eloado']);
                end;
        queryearesz.close;
        end;
end;

procedure TForm1.ListboxeaClick(Sender: TObject);
begin
betolt;
end;

procedure tform1.aktival(aktiv:boolean);
begin
buttonuj.enabled:=not aktiv;
buttonmod.enabled:=not aktiv;
buttontorol.Enabled:=not aktiv;
buttonment.Enabled:=aktiv;
buttonmegsem.Enabled:=aktiv;

editazon.ReadOnly:=not aktiv;
editcim.ReadOnly:=not aktiv;
edithossz.ReadOnly:=not aktiv;
//editeloado.ReadOnly:=not aktiv;
listboxea.Enabled:=not aktiv;
end;

procedure tform1.sqlfuttat(sql:tquery; torles:boolean);
begin
sql.ParamByName('eazon').asString:=editazon.Text;
if not torles then
        begin
        sql.ParamByName('cim').AsString:=editcim.text;
        sql.ParamByName('hossz').AsString:=edithossz.text;
        sql.ParamByName('eloado').AsString:=eloadok[comboea.itemindex];
        end;
sql.ExecSQL;
end;

procedure TForm1.ButtonujClick(Sender: TObject);
begin
editazon.text:='';
editcim.text:='';
edithossz.text:='';
comboea.itemindex:=-1;
uje:=true;
aktival(true);
end;

procedure TForm1.ButtonmodClick(Sender: TObject);
begin
uje:=false;
aktival(true);
editazon.readonly:=true;
end;

procedure TForm1.ButtontorolClick(Sender: TObject);
begin
if messagedlg('Biztos hogy trli a '+editcim.text+' eloadast?', mtconfirmation,
                [mbyes,mbno,mbcancel],0)=mryes then
                        begin
                        sqlfuttat(deleteeloadas,true);
                        frissit;
                        end;
end;



procedure TForm1.buttonmentClick(Sender: TObject);
begin
if uje then
        begin
        sqlfuttat(inserteloado,false);
        end else
                begin
                sqlfuttat(updateeloadas,false);
                end;
        frissit;
        aktival(false);

end;

procedure TForm1.buttonmegsemClick(Sender: TObject);
begin
frissit;
aktival(false);

end;

end.
